#**************************************************************
# This .sdc file is created by Terasic Tool.
# Users are recommended to modify this file to match users logic.
#**************************************************************

#**************************************************************
# Create Clock
#**************************************************************
create_clock -period "10.0 MHz" [get_ports ADC_CLK_10]
create_clock -period "50.0 MHz" [get_ports MAX10_CLK1_50]
create_clock -period "50.0 MHz" [get_ports MAX10_CLK2_50]

#**************************************************************
# Create Generated Clock
#**************************************************************
derive_pll_clocks

#create_generated_clock -name CLOCK_DDR_CK  -source [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}]
#create_generated_clock -name CLOCK_DDR_WDQ -source [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}]
#create_generated_clock -name CLOCK_DDR_RDQ -source [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[2]}]

#**************************************************************
# Set Clock Latency
#**************************************************************



#**************************************************************
# Set Clock Uncertainty
#**************************************************************
derive_clock_uncertainty

#Specify the required tSU
set tSU 1.500
#Specify the required tH
set tH  2.000
#Specify the required tCO
set tCO  -7.000
#Specify the required tCOm
set tCOm -4.000


##**************************************************************
## Set Input Delay
##**************************************************************
#
set_input_delay  -clock MAX10_CLK1_50 -max $tSU  [get_ports {GPIO0_D[*]}]
set_input_delay  -clock MAX10_CLK1_50 -min $tH   [get_ports {GPIO0_D[*]}]
set_input_delay  -clock MAX10_CLK1_50 -max $tSU  [get_ports {KEY[*]}]
set_input_delay  -clock MAX10_CLK1_50 -min $tH   [get_ports {KEY[*]}]
set_input_delay  -clock MAX10_CLK1_50 -max $tSU  [get_ports {SW[*]}]
set_input_delay  -clock MAX10_CLK1_50 -min $tH   [get_ports {SW[*]}]
set_input_delay  -clock MAX10_CLK1_50 -max $tSU  [get_ports {HDMI_I2C_SDA}]
set_input_delay  -clock MAX10_CLK1_50 -min $tH   [get_ports {HDMI_I2C_SDA}]
set_input_delay  -clock MAX10_CLK1_50 -max $tSU  [get_ports {HDMI_TX_INT}]
set_input_delay  -clock MAX10_CLK1_50 -min $tH   [get_ports {HDMI_TX_INT}]
#
set_input_delay  -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[2]}]             -max -add_delay $tSU [get_ports {DDR3_DQS_*[*]}]
set_input_delay  -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[2]}]             -min -add_delay $tH  [get_ports {DDR3_DQS_*[*]}]
set_input_delay  -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[2]}]             -max -add_delay $tSU [get_ports {DDR3_DQ[*]}]
set_input_delay  -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[2]}]             -min -add_delay $tH  [get_ports {DDR3_DQ[*]}]
set_input_delay  -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[2]}] -clock_fall -max -add_delay $tSU [get_ports {DDR3_DQS_*[*]}]
set_input_delay  -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[2]}] -clock_fall -min -add_delay $tH  [get_ports {DDR3_DQS_*[*]}]
set_input_delay  -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[2]}] -clock_fall -max -add_delay $tSU [get_ports {DDR3_DQ[*]}]
set_input_delay  -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[2]}] -clock_fall -min -add_delay $tH  [get_ports {DDR3_DQ[*]}]
#
#
##**************************************************************
## Set Output Delay
##**************************************************************
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -max $tCO              [get_ports {DDR3_CK_*[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -max $tCO  -clock_fall [get_ports {DDR3_CK_*[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -min $tCOm             [get_ports {DDR3_CK_*[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -min $tCOm -clock_fall [get_ports {DDR3_CK_*[*]}] -add_delay

set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -max $tCO              [get_ports {DDR3_DQS_*[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -max $tCO  -clock_fall [get_ports {DDR3_DQS_*[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -min $tCOm             [get_ports {DDR3_DQS_*[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -min $tCOm -clock_fall [get_ports {DDR3_DQS_*[*]}] -add_delay

set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -max $tCO              [get_ports {DDR3*}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -max $tCO  -clock_fall [get_ports {DDR3*}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -min $tCOm             [get_ports {DDR3*}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -min $tCOm -clock_fall [get_ports {DDR3*}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -max $tCO              [get_ports {DDR3_A[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -max $tCO  -clock_fall [get_ports {DDR3_A[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -min $tCOm             [get_ports {DDR3_A[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -min $tCOm -clock_fall [get_ports {DDR3_A[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -max $tCO              [get_ports {DDR3_BA[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -max $tCO  -clock_fall [get_ports {DDR3_BA[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -min $tCOm             [get_ports {DDR3_BA[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -min $tCOm -clock_fall [get_ports {DDR3_BA[*]}] -add_delay

set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -max $tCO              [get_ports {DDR3_DM[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -max $tCO  -clock_fall [get_ports {DDR3_DM[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -min $tCOm             [get_ports {DDR3_DM[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -min $tCOm -clock_fall [get_ports {DDR3_DM[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -max $tCO              [get_ports {DDR3_DQ[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -max $tCO  -clock_fall [get_ports {DDR3_DQ[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -min $tCOm             [get_ports {DDR3_DQ[*]}] -add_delay
set_output_delay -clock [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -min $tCOm -clock_fall [get_ports {DDR3_DQ[*]}] -add_delay

set_output_delay -clock MAX10_CLK1_50 -max $tCO  [get_ports {GPIO0_D[*]}]
set_output_delay -clock MAX10_CLK1_50 -min $tCOm [get_ports {GPIO0_D[*]}]
set_output_delay -clock MAX10_CLK1_50 -max $tCO  [get_ports {LED[*]}]
set_output_delay -clock MAX10_CLK1_50 -min $tCOm [get_ports {LED[*]}]
#
set_output_delay -clock MAX10_CLK1_50 -max $tCO  [get_ports {HDMI*}]
set_output_delay -clock MAX10_CLK1_50 -min $tCOm [get_ports {HDMI*}]


#**************************************************************
# Set Clock Groups
#**************************************************************



#**************************************************************
# Set False Path
#**************************************************************

set_false_path -setup -rise_from [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -fall_to [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}]
set_false_path -setup -fall_from [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -rise_to [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}]
set_false_path -hold  -rise_from [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -rise_to [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}]
set_false_path -hold  -fall_from [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -fall_to [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}]

set_false_path -setup -rise_from [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -fall_to [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}]
set_false_path -setup -fall_from [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -rise_to [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}]
set_false_path -hold  -rise_from [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -rise_to [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}]
set_false_path -hold  -fall_from [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -fall_to [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}]

set_false_path -setup -rise_from [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[2]}] -fall_to [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[2]}]
set_false_path -setup -fall_from [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[2]}] -rise_to [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[2]}]
set_false_path -hold  -rise_from [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[2]}] -rise_to [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[2]}]
set_false_path -hold  -fall_from [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[2]}] -fall_to [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[2]}]

set_false_path -setup -rise_from [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -fall_to [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}]
set_false_path -setup -fall_from [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -rise_to [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}]
set_false_path -hold  -rise_from [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -rise_to [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}]
set_false_path -hold  -fall_from [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[1]}] -fall_to [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}]


#**************************************************************
# Set Multicycle Path
#**************************************************************

set_multicycle_path -setup -end -from  [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}]  -to  [get_clocks {MAX10_CLK1_50}] 2
set_multicycle_path -from  [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}]  -to  [get_clocks {MAX10_CLK1_50}] -hold -end 1
set_multicycle_path -setup -end -from  [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[3]}]  -to  [get_clocks {MAX10_CLK1_50}] 2
set_multicycle_path -from  [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[3]}]  -to  [get_clocks {MAX10_CLK1_50}] -hold -end 1
set_multicycle_path -setup -end -from  [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[4]}]  -to  [get_clocks {MAX10_CLK1_50}] 2
set_multicycle_path -from  [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[4]}]  -to  [get_clocks {MAX10_CLK1_50}] -hold -end 1
set_multicycle_path -setup -end -from  [get_clocks {MAX10_CLK1_50}]  -to  [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] 2
set_multicycle_path -from  [get_clocks {MAX10_CLK1_50}]  -to  [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[0]}] -hold -end 1
set_multicycle_path -setup -end -from  [get_clocks {MAX10_CLK1_50}]  -to  [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[3]}] 2
set_multicycle_path -from  [get_clocks {MAX10_CLK1_50}]  -to  [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[3]}] -hold -end 1
set_multicycle_path -setup -end -from  [get_clocks {MAX10_CLK1_50}]  -to  [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[4]}] 2
set_multicycle_path -from  [get_clocks {MAX10_CLK1_50}]  -to  [get_clocks {BHG_DDR3_PLL|HPLL1|auto_generated|pll1|clk[4]}] -hold -end 1

#**************************************************************
# Set Maximum Delay
#**************************************************************



#**************************************************************
# Set Minimum Delay
#**************************************************************



#**************************************************************
# Set Input Transition
#**************************************************************



#**************************************************************
# Set Load
#**************************************************************
